import sys
import binascii

filenameExportBase = "Get_Sibelius_Version_Data.txt"

#Functions choose version based on file header data

def switch_4hexbytes(bytes):
	switcher = {
			binascii.unhexlify(b'002D0003'): "Sibelius 5.0",
			binascii.unhexlify(b'002D000D'): "Sibelius 5.1",
			binascii.unhexlify(b'002D0010'): "Sibelius 5.2.x",
			binascii.unhexlify(b'00360001'): "Sibelius 6.0.x",
			binascii.unhexlify(b'00360017'): "Sibelius 6.1",
			binascii.unhexlify(b'0036001E'): "Sibelius 6.2",
			binascii.unhexlify(b'0039000C'): "Sibelius 7.0",
			binascii.unhexlify(b'0039000E'): "Sibelius 7.0.1 - 7.0.2",
			binascii.unhexlify(b'00390013'): "Sibelius 7.0.3",
			binascii.unhexlify(b'00390015'): "Sibelius 7.1.0",
			binascii.unhexlify(b'00390016'): "Sibelius 7.1.2 - 7.1.3",
			binascii.unhexlify(b'003D000E'): "Sibelius 7.5.x",
			binascii.unhexlify(b'003D0010'): "Sibelius 8.0.0 - 8.0.1",
			binascii.unhexlify(b'003E0000'): "Sibelius 8.1.x",
			binascii.unhexlify(b'003E0001'): "Sibelius 8.2",
			binascii.unhexlify(b'003E0002'): "Sibelius 8.3",
			binascii.unhexlify(b'003E0006'): "Sibelius 8.4.x",
			binascii.unhexlify(b'003E0007'): "Sibelius 8.5.x",
			binascii.unhexlify(b'003F0000'): "Sibelius 8.6.x -  8.7.0 -  8.7.1",
			binascii.unhexlify(b'003F0001'): "Sibelius 8.7.2  - 2018.7",
			binascii.unhexlify(b'003F0002'): "Sibelius 2018.11 - 2018.12",
			binascii.unhexlify(b'003F0004'): "Sibelius 2019.1 - 2019.3 ",
			binascii.unhexlify(b'003F0005'): "Sibelius 2019.4",
			binascii.unhexlify(b'003F0006'): "Sibelius 2019.4 - 2019.12",
			binascii.unhexlify(b'003F0007'): "Sibelius 2019.4 - 2019.12",
			binascii.unhexlify(b'003F0009'): "Sibelius 2019.4 - 2019.12",
			binascii.unhexlify(b'003F000a'): "Sibelius 2019.4 - 2019.12",
			binascii.unhexlify(b'003F000b'): "Sibelius 2020.1",
			binascii.unhexlify(b'00400001'): "Sibelius 2020.3 or later"
	}
	return switcher.get(bytes,"Unrecognized format")	
	
def switch_2hexbytes(bytes):
	switcher2 = {
			binascii.unhexlify(b'0008'): "Sibelius 2.x",
			binascii.unhexlify(b'000A'): "Sibelius 3.x",
			binascii.unhexlify(b'001B'): "Sibelius 4.x",
			binascii.unhexlify(b'001C'): "Sibelius 4.x"	
	}
	return switcher2.get(bytes,"Unrecognized format")		

def GetVersion(filename):	
	fVerbose = True
	with open(filename, "rb") as binary_file:

		if filename.endswith('.sib') == False :
			print 'Please select a Sibelius file with a .sib extension'
			return ''
		else:
			# Seek position and read N bytes
			binary_file.seek(10)  # Go to byte 10
			four_bytes = binary_file.read(4)

			val =  switch_4hexbytes(four_bytes)
			#print("Val 1, 4 bytes", val, four_bytes);
			if val == "Unrecognized format":
						binary_file.seek(10)  # Go to byte 10
						two_bytes = binary_file.read(2)
						val =  switch_2hexbytes(two_bytes)
						#print("Val2, four_bytes, two_bytes", val, four_bytes, two_bytes)
						
						if val == "Unrecognized format":  # 2nd failure
							str4BytesAscii = binascii.hexlify(four_bytes)
							val = val + ",{" + str(str4BytesAscii) + "}"
						elif fVerbose:		
							str4BytesAscii = binascii.hexlify(four_bytes)
							val = val + ",{" + str(str4BytesAscii) + "}"				
			elif fVerbose:
				str4BytesAscii = binascii.hexlify(four_bytes)
				val = val + ",{" + str(str4BytesAscii) + "}"		
						
			return val


def ProcessFolder():
	root.directory = tkFileDialog.askdirectory(title = "Choose a folder containing Sibelius scores. Subfolders will not be included.")
	strFolder =  'Get Saved Sibelius Version processing folder:' +  root.directory
	textItem.insert(END, strFolder +"\n")
	textItem.insert(END, "---" + "\n")

	for (dirname, dirs, files) in os.walk(root.directory):
		for filename in files:
			if filename.endswith('.sib') :
				ver = GetVersion(os.path.join(dirname, filename))
				if ver:  # empty string evaluates false
					strVer = ver + ',' + filename
					textItem.insert(END, strVer + '\n')				
					
		textItem.insert(END, "---" + '\n')
		return dirname
					
def ProcessFile():
	root.filename =  tkFileDialog.askopenfilename(title = "Select Sibelius score file",filetypes = (("sib files","*.sib"),("all files","*.*")))
	
	ver = GetVersion(root.filename)
	if ver:  # empty string evaluates false
		strVer = ver +  ',' +  root.filename
		textItem.insert(END, strVer + '\n')	
	return root.filename

def getFolder():
    ProcessFolder()
    
def getFile():
	ProcessFile()
	
def clearList():
	# delete contents of present listbox
	#textItem.delete(0, tk.END)
	textItem.delete("1.0",tk.END)  # weird but seems to be how this works

def selectList():
	# select contents of present textItem
	#textItem.delete("1.0",tk.END)  # weird but seems to be how this works	
	#textItem.select_range(0, END)
	textItem.tag_add(SEL, "1.0", END)
	textItem.focus_set()

from Tkinter import *
import Tkinter, Tkconstants, tkFileDialog, tkMessageBox
import os

import Tkinter as tk

from tkMessageBox import *

root = Tk() # Get the root object from Tkinter

# Add a label to the dialog

versionCur = "01.05.00"
root.title("Get Saved Sibelius Version - by Bob Zawalich - Version " + versionCur)

labelExplain1 = Label(root, text="Examine Sibelius score files and determine the version of Sibelius they were last saved in.").grid(row=1, sticky = 'w')
labelExplain2 = Label(root, text="You can look at a single score or a folder of scores. Subfolders will not be included. Copy and paste from the list of results.").grid(row=2, sticky = 'w')

# Add a text box to hold the results

strList= "*** Sibelius version, (binary bytes 10 - 12), file name"  
textItem = tk.Text(root, wrap=WORD, height=40, width=120)
textItem.grid(row=4, column=0, sticky = 'w')

scrollBarT = Scrollbar(root)
scrollBarT.grid(row=4, column=1, sticky = 'wns')

textItem.config(width=120,height=40,yscrollcommand=scrollBarT.set)
scrollBarT.config(command=textItem.yview)

textItem.insert(END, strList + "\n")
textItem.insert(END, "---")

# Add buttons to the dialog

bFile = tk.Button(root, 
                   text="Get File", 
                   command=getFile)
bFile.grid(row=5, column=1, sticky = 'w')

bFolder = tk.Button(root,
                   text="Get Folder",
                   command=getFolder)
bFolder.grid(row=5, column=2)

bSelectAll = tk.Button(root,
                   text="Select All in List",
                   command=selectList)
bSelectAll.grid(row=5, column=3, sticky = 'w')

bClear = tk.Button(root,
                   text="Clear List",
                   command=clearList)
bClear.grid(row=5, column=4, sticky = 'w')

bQuit = tk.Button(root,
                   text="Quit",
                   command=root.quit)
bQuit.grid(row=5, column=5, sticky = 'w')


# Loop until the user closes the dialog

root.mainloop() 
